"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createLifter = createLifter;
exports.withLiftedProps = withLiftedProps;

var _react = _interopRequireDefault(require("react"));

var _hoistNonReactStatics = _interopRequireDefault(require("hoist-non-react-statics"));

var _context = _interopRequireDefault(require("./context"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var Lifters = function Lifters(_ref) {
  var children = _ref.children;
  return children;
};

function createLifter() {
  var _class, _temp, _class2, _temp2;

  var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var Lifter = (_temp = _class =
  /*#__PURE__*/
  function (_React$PureComponent) {
    _inherits(Lifter, _React$PureComponent);

    // tslint:disable-line max-classes-per-file
    function Lifter(props) {
      var _this;

      _classCallCheck(this, Lifter);

      _this = _possibleConstructorReturn(this, (Lifter.__proto__ || Object.getPrototypeOf(Lifter)).call(this, props));
      Object.defineProperty(_assertThisInitialized(_this), "componentId", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: void 0
      });
      Object.defineProperty(_assertThisInitialized(_this), "lifterRef", {
        configurable: true,
        enumerable: true,
        writable: true,
        value: void 0
      });
      _this.componentId = -1;
      _this.lifterRef = _react.default.createRef();
      return _this;
    }

    _createClass(Lifter, [{
      key: "componentWillUnmount",
      value: function componentWillUnmount() {
        this.removeProps();
      }
    }, {
      key: "componentDidMount",
      value: function componentDidMount() {
        var _this2 = this;

        // This is a little hacky, but it's the best way I can think of
        // to determine the index this lifter is in the DOM. It also means this
        // will only work with ReactDOM :(
        if (this.props.contextValue) {
          var domNodes = document.querySelectorAll(".".concat(this.getClassName()));

          var index = _toConsumableArray(domNodes).findIndex(function (domNode) {
            return domNode === _this2.lifterRef.current;
          });

          this.componentId = this.props.contextValue.registerComponent(index);
        }

        this.liftProps();
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate() {
        this.liftProps();
      }
    }, {
      key: "removeProps",
      value: function removeProps() {
        if (this.props.contextValue) {
          this.props.contextValue.removeProps(this.componentId);
        }
      }
    }, {
      key: "liftProps",
      value: function liftProps() {
        var props = _objectSpread({}, this.props);

        delete props.contextValue;

        if (this.props.contextValue) {
          this.props.contextValue.liftProps(this.componentId, props);
        }
      }
    }, {
      key: "getClassName",
      value: function getClassName() {
        if (this.props.contextValue && this.props.contextValue.id) {
          return "__react-lift-props-lifter__".concat(this.props.contextValue.id, "__");
        }

        return "__react-lift-props-lifter__";
      }
    }, {
      key: "render",
      value: function render() {
        return _react.default.createElement("div", {
          className: this.getClassName(),
          ref: this.lifterRef
        });
      }
    }]);

    return Lifter;
  }(_react.default.PureComponent), Object.defineProperty(_class, "displayName", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: "Lifter"
  }), _temp);
  var WrappedLifter = (_temp2 = _class2 =
  /*#__PURE__*/
  function (_React$PureComponent2) {
    _inherits(WrappedLifter, _React$PureComponent2);

    function WrappedLifter() {
      _classCallCheck(this, WrappedLifter);

      return _possibleConstructorReturn(this, (WrappedLifter.__proto__ || Object.getPrototypeOf(WrappedLifter)).apply(this, arguments));
    }

    _createClass(WrappedLifter, [{
      key: "render",
      // tslint:disable-line max-classes-per-file
      value: function render() {
        var _this3 = this;

        return _react.default.createElement(_react.default.Fragment, null, _react.default.createElement(_context.default.Consumer, null, function (contextValue) {
          return _react.default.createElement(Lifter, _extends({}, _this3.props, options.extraProps, {
            contextValue: contextValue
          }));
        }), options.wrapper && this.props.children);
      }
    }]);

    return WrappedLifter;
  }(_react.default.PureComponent), Object.defineProperty(_class2, "displayName", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: options.displayName || "Wrapped(Lifter)"
  }), _temp2);
  return WrappedLifter;
}

var parentIdCounter = 0;

function withLiftedProps(component) {
  var _class3, _temp3, _initialiseProps;

  var WrappedComponent = (_temp3 = _class3 =
  /*#__PURE__*/
  function (_React$PureComponent3) {
    _inherits(WrappedComponent, _React$PureComponent3);

    // tslint:disable-line max-classes-per-file
    function WrappedComponent(props) {
      var _this4;

      _classCallCheck(this, WrappedComponent);

      _this4 = _possibleConstructorReturn(this, (WrappedComponent.__proto__ || Object.getPrototypeOf(WrappedComponent)).call(this, props));

      _initialiseProps.call(_assertThisInitialized(_this4));

      _this4.id = parentIdCounter = parentIdCounter + 1;
      _this4.contextValue = {
        id: _this4.id,
        liftProps: _this4.liftProps,
        registerComponent: _this4.registerComponent,
        removeProps: _this4.removeProps
      };
      return _this4;
    }

    _createClass(WrappedComponent, [{
      key: "updateLiftedProps",
      value: function updateLiftedProps() {
        var liftedProps = this.liftedProps.map(function (propsHolder) {
          return propsHolder.props;
        }).filter(Boolean);
        this.setState({
          liftedProps: liftedProps
        });
      }
    }, {
      key: "render",
      value: function render() {
        var props = _objectSpread({}, this.props);

        delete props.children;
        return _react.default.createElement(_context.default.Provider, {
          value: this.contextValue
        }, _react.default.createElement(Lifters, null, this.props.children), this.state && this.state.liftedProps && _react.default.createElement(component, _objectSpread({}, props, {
          liftedProps: this.state.liftedProps
        })));
      }
    }]);

    return WrappedComponent;
  }(_react.default.PureComponent), Object.defineProperty(_class3, "displayName", {
    configurable: true,
    enumerable: true,
    writable: true,
    value: "withLiftedProps(".concat((0, _utils.getDisplayName)(component), ")")
  }), _initialiseProps = function _initialiseProps() {
    var _this5 = this;

    Object.defineProperty(this, "idCounter", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: 0
    });
    Object.defineProperty(this, "id", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: 0
    });
    Object.defineProperty(this, "liftedProps", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: []
    });
    Object.defineProperty(this, "contextValue", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, "registerComponent", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(index) {
        var componentId = _this5.idCounter = _this5.idCounter + 1;

        var newLiftedProps = _toConsumableArray(_this5.liftedProps);

        if (newLiftedProps[index]) {
          newLiftedProps.splice(index, 0, {
            id: componentId
          });
        } else {
          newLiftedProps.push({
            id: componentId
          });
        }

        _this5.liftedProps = newLiftedProps;
        return componentId;
      }
    });
    Object.defineProperty(this, "removeProps", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(id) {
        var newLiftedProps = _this5.liftedProps.filter(function (propsHolder) {
          return propsHolder.id !== id;
        });

        _this5.liftedProps = newLiftedProps;

        _this5.updateLiftedProps();
      }
    });
    Object.defineProperty(this, "liftProps", {
      configurable: true,
      enumerable: true,
      writable: true,
      value: function value(id, props) {
        var newLiftedProps = _this5.liftedProps.map(function (propsHolder) {
          if (propsHolder.id === id) {
            return {
              id: id,
              props: props
            };
          }

          return propsHolder;
        });

        _this5.liftedProps = newLiftedProps;

        _this5.updateLiftedProps();
      }
    });
  }, _temp3);
  return (0, _hoistNonReactStatics.default)(WrappedComponent, component);
}